commit ea74de4d9e35711a243e3fcc42f43e65a7efc31f
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Wed Nov 1 12:43:31 2017 -0500

    Test: pengine: add regression test for on-fail=ignore

Index: pacemaker-1.1.16+20170320.77ea74d/pengine/regression.sh
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/regression.sh
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/regression.sh
@@ -537,6 +537,7 @@ do_test bug-5025-4 "Clear failcount when
 do_test failcount "Ensure failcounts are correctly expired"
 do_test failcount-block "Ensure failcounts are not expired when on-fail=block is present"
 do_test per-op-failcount "Ensure per-operation failcount is handled and not passed to fence agent"
+do_test on-fail-ignore "Ensure on-fail=ignore works even beyond migration-threshold"
 do_test monitor-onfail-restart "bug-5058 - Monitor failure with on-fail set to restart"
 do_test monitor-onfail-stop    "bug-5058 - Monitor failure wiht on-fail set to stop"
 do_test bug-5059 "No need to restart p_stateful1:*"
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.dot
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.dot
@@ -0,0 +1,15 @@
+digraph "g" {
+"all_stopped" [ style=bold color="green" fontcolor="orange"]
+"fence_db1_monitor_60000 407892-db2" [ style=bold color="green" fontcolor="black"]
+"fence_db1_start_0 407892-db2" -> "fence_db1_monitor_60000 407892-db2" [ style = bold]
+"fence_db1_start_0 407892-db2" [ style=bold color="green" fontcolor="black"]
+"fence_db1_stop_0 407892-db2" -> "all_stopped" [ style = bold]
+"fence_db1_stop_0 407892-db2" -> "fence_db1_start_0 407892-db2" [ style = bold]
+"fence_db1_stop_0 407892-db2" [ style=bold color="green" fontcolor="black"]
+"fence_db2_monitor_60000 407888-db1" [ style=bold color="green" fontcolor="black"]
+"fence_db2_start_0 407888-db1" -> "fence_db2_monitor_60000 407888-db1" [ style = bold]
+"fence_db2_start_0 407888-db1" [ style=bold color="green" fontcolor="black"]
+"fence_db2_stop_0 407888-db1" -> "all_stopped" [ style = bold]
+"fence_db2_stop_0 407888-db1" -> "fence_db2_start_0 407888-db1" [ style = bold]
+"fence_db2_stop_0 407888-db1" [ style=bold color="green" fontcolor="black"]
+}
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.exp
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.exp
@@ -0,0 +1,87 @@
+<transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
+  <synapse id="0">
+    <action_set>
+      <rsc_op id="7" operation="stop" operation_key="fence_db1_stop_0" on_node="407892-db2" on_node_uuid="2">
+        <primitive id="fence_db1" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_on_node="407892-db2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000"  delay="4" ipaddr="192.168.103.3" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407888-db1" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="1">
+    <action_set>
+      <rsc_op id="6" operation="start" operation_key="fence_db1_start_0" on_node="407892-db2" on_node_uuid="2">
+        <primitive id="fence_db1" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_on_node="407892-db2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000"  delay="4" ipaddr="192.168.103.3" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407888-db1" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="fence_db1_stop_0" on_node="407892-db2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="2">
+    <action_set>
+      <rsc_op id="3" operation="monitor" operation_key="fence_db1_monitor_60000" on_node="407892-db2" on_node_uuid="2">
+        <primitive id="fence_db1" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="407892-db2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000"  delay="4" ipaddr="192.168.103.3" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407888-db1" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="6" operation="start" operation_key="fence_db1_start_0" on_node="407892-db2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="3">
+    <action_set>
+      <rsc_op id="8" operation="stop" operation_key="fence_db2_stop_0" on_node="407888-db1" on_node_uuid="1">
+        <primitive id="fence_db2" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_on_node="407888-db1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000"  ipaddr="192.168.103.4" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407892-db2" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="4">
+    <action_set>
+      <rsc_op id="5" operation="start" operation_key="fence_db2_start_0" on_node="407888-db1" on_node_uuid="1">
+        <primitive id="fence_db2" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_on_node="407888-db1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000"  ipaddr="192.168.103.4" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407892-db2" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="8" operation="stop" operation_key="fence_db2_stop_0" on_node="407888-db1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="5">
+    <action_set>
+      <rsc_op id="1" operation="monitor" operation_key="fence_db2_monitor_60000" on_node="407888-db1" on_node_uuid="1">
+        <primitive id="fence_db2" class="stonith" type="fence_ipmilan"/>
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="407888-db1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000"  ipaddr="192.168.103.4" lanplus="1" login="root" method="onoff" passwd="****" pcmk_host_check="static-list" pcmk_host_list="407892-db2" power_wait="4"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="start" operation_key="fence_db2_start_0" on_node="407888-db1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6">
+    <action_set>
+      <pseudo_event id="4" operation="all_stopped" operation_key="all_stopped">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="7" operation="stop" operation_key="fence_db1_stop_0" on_node="407892-db2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="stop" operation_key="fence_db2_stop_0" on_node="407888-db1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+</transition_graph>
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.scores
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.scores
@@ -0,0 +1,8 @@
+Allocation scores:
+Using the original execution date of: 2017-10-26 14:23:50Z
+native_color: fence_db1 allocation score on 407888-db1: 0
+native_color: fence_db1 allocation score on 407892-db2: 100
+native_color: fence_db2 allocation score on 407888-db1: 100
+native_color: fence_db2 allocation score on 407892-db2: 0
+native_color: nfs_snet_ip allocation score on 407888-db1: 100
+native_color: nfs_snet_ip allocation score on 407892-db2: 0
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.summary
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.summary
@@ -0,0 +1,30 @@
+Using the original execution date of: 2017-10-26 14:23:50Z
+
+Current cluster status:
+Online: [ 407888-db1 407892-db2 ]
+
+ fence_db1	(stonith:fence_ipmilan):	Started 407892-db2
+ fence_db2	(stonith:fence_ipmilan):	Started 407888-db1
+ nfs_snet_ip	(ocf::heartbeat:IPaddr2):	Started 407888-db1 (failure ignored)
+
+Transition Summary:
+ * Restart fence_db1	(Started 407892-db2)
+ * Restart fence_db2	(Started 407888-db1)
+
+Executing cluster transition:
+ * Resource action: fence_db1       stop on 407892-db2
+ * Resource action: fence_db1       start on 407892-db2
+ * Resource action: fence_db1       monitor=60000 on 407892-db2
+ * Resource action: fence_db2       stop on 407888-db1
+ * Resource action: fence_db2       start on 407888-db1
+ * Resource action: fence_db2       monitor=60000 on 407888-db1
+ * Pseudo action:   all_stopped
+Using the original execution date of: 2017-10-26 14:23:50Z
+
+Revised cluster status:
+Online: [ 407888-db1 407892-db2 ]
+
+ fence_db1	(stonith:fence_ipmilan):	Started 407892-db2
+ fence_db2	(stonith:fence_ipmilan):	Started 407888-db1
+ nfs_snet_ip	(ocf::heartbeat:IPaddr2):	Started 407888-db1 (failure ignored)
+
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.xml
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/on-fail-ignore.xml
@@ -0,0 +1,113 @@
+<cib crm_feature_set="3.0.12" validate-with="pacemaker-2.7" epoch="40" num_updates="16" admin_epoch="0" cib-last-written="Sat Oct 21 10:28:39 2017" update-origin="407888-db1" update-client="cibadmin" update-user="root" have-quorum="1" dc-uuid="1" execution-date="1509027830">
+  <configuration>
+    <crm_config>
+      <cluster_property_set id="cib-bootstrap-options">
+        <nvpair id="cib-bootstrap-options-have-watchdog" name="have-watchdog" value="false"/>
+        <nvpair id="cib-bootstrap-options-dc-version" name="dc-version" value="1.1.16-12.el7_4.2-94ff4df"/>
+        <nvpair id="cib-bootstrap-options-cluster-infrastructure" name="cluster-infrastructure" value="corosync"/>
+        <nvpair id="cib-bootstrap-options-cluster-name" name="cluster-name" value="clus_mysqlc"/>
+        <nvpair id="cib-bootstrap-options-default-resource-stickiness" name="default-resource-stickiness" value="100"/>
+      </cluster_property_set>
+    </crm_config>
+    <nodes>
+      <node id="1" uname="407888-db1"/>
+      <node id="2" uname="407892-db2"/>
+    </nodes>
+    <resources>
+      <primitive class="stonith" id="fence_db1" type="fence_ipmilan">
+        <instance_attributes id="fence_db1-instance_attributes">
+          <nvpair id="fence_db1-instance_attributes-delay" name="delay" value="4"/>
+          <nvpair id="fence_db1-instance_attributes-ipaddr" name="ipaddr" value="192.168.103.3"/>
+          <nvpair id="fence_db1-instance_attributes-lanplus" name="lanplus" value="1"/>
+          <nvpair id="fence_db1-instance_attributes-login" name="login" value="root"/>
+          <nvpair id="fence_db1-instance_attributes-method" name="method" value="onoff"/>
+          <nvpair id="fence_db1-instance_attributes-passwd" name="passwd" value="****"/>
+          <nvpair id="fence_db1-instance_attributes-pcmk_host_check" name="pcmk_host_check" value="static-list"/>
+          <nvpair id="fence_db1-instance_attributes-pcmk_host_list" name="pcmk_host_list" value="407888-db1"/>
+          <nvpair id="fence_db1-instance_attributes-power_wait" name="power_wait" value="4"/>
+        </instance_attributes>
+        <operations>
+          <op id="fence_db1-monitor-interval-60s" interval="60s" name="monitor"/>
+        </operations>
+      </primitive>
+      <primitive class="stonith" id="fence_db2" type="fence_ipmilan">
+        <instance_attributes id="fence_db2-instance_attributes">
+          <nvpair id="fence_db2-instance_attributes-ipaddr" name="ipaddr" value="192.168.103.4"/>
+          <nvpair id="fence_db2-instance_attributes-lanplus" name="lanplus" value="1"/>
+          <nvpair id="fence_db2-instance_attributes-login" name="login" value="root"/>
+          <nvpair id="fence_db2-instance_attributes-method" name="method" value="onoff"/>
+          <nvpair id="fence_db2-instance_attributes-passwd" name="passwd" value="****"/>
+          <nvpair id="fence_db2-instance_attributes-pcmk_host_check" name="pcmk_host_check" value="static-list"/>
+          <nvpair id="fence_db2-instance_attributes-pcmk_host_list" name="pcmk_host_list" value="407892-db2"/>
+          <nvpair id="fence_db2-instance_attributes-power_wait" name="power_wait" value="4"/>
+        </instance_attributes>
+        <operations>
+          <op id="fence_db2-monitor-interval-60s" interval="60s" name="monitor"/>
+        </operations>
+      </primitive>
+        <primitive class="ocf" id="nfs_snet_ip" provider="heartbeat" type="IPaddr2">
+          <instance_attributes id="nfs_snet_ip-instance_attributes">
+            <nvpair id="nfs_snet_ip-instance_attributes-ip" name="ip" value="10.136.132.228"/>
+          </instance_attributes>
+          <meta_attributes id="nfs_snet_ip-meta_attributes">
+            <nvpair id="nfs_snet_ip-meta_attributes-migration-threshold" name="migration-threshold" value="2"/>
+          </meta_attributes>
+          <operations>
+            <op id="nfs_snet_ip-monitor-interval-10s" interval="10s" name="monitor" on-fail="ignore" timeout="10s"/>
+            <op id="nfs_snet_ip-start-interval-0s" interval="0s" name="start" timeout="20s"/>
+            <op id="nfs_snet_ip-stop-interval-0s" interval="0s" name="stop" timeout="20s"/>
+          </operations>
+        </primitive>
+    </resources>
+    <constraints/>
+  </configuration>
+  <status>
+    <node_state id="1" uname="407888-db1" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="1">
+        <lrm_resources>
+          <lrm_resource id="fence_db1" type="fence_ipmilan" class="stonith">
+            <lrm_rsc_op id="fence_db1_last_0" operation_key="fence_db1_stop_0" operation="stop" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="3:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;3:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="9" rc-code="0" op-status="0" interval="0" last-run="1508577153" last-rc-change="1508577153" exec-time="0" queue-time="0" op-digest="5397ff9100b6061844743be1480cacb6" op-secure-params=" passwd  password " op-secure-digest="d7ead554cd349871ab13dad142fdd3f9"/>
+            <lrm_rsc_op id="fence_db1_monitor_60000" operation_key="fence_db1_monitor_60000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="5:2:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;5:2:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="7" rc-code="0" op-status="0" interval="60000" last-rc-change="1508577153" exec-time="121" queue-time="0" op-digest="0f2ec8ca9089ba249057558bf057a7e8" op-secure-params=" passwd  password " op-secure-digest="d7ead554cd349871ab13dad142fdd3f9"/>
+          </lrm_resource>
+          <lrm_resource id="fence_db2" type="fence_ipmilan" class="stonith">
+            <lrm_rsc_op id="fence_db2_last_0" operation_key="fence_db2_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="7:4:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;7:4:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="14" rc-code="0" op-status="0" interval="0" last-run="1508577161" last-rc-change="1508577161" exec-time="121" queue-time="0" op-digest="16a37bd94b2a5efbc774fb6ac0ed7a4c" op-secure-params=" passwd  password " op-secure-digest="6cecd340b584b96981bffee3e535ff98"/>
+            <lrm_rsc_op id="fence_db2_monitor_60000" operation_key="fence_db2_monitor_60000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="8:4:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;8:4:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="15" rc-code="0" op-status="0" interval="60000" last-rc-change="1508577162" exec-time="117" queue-time="0" op-digest="48e93a15224b9a84a6af5e82a7eab9e1" op-secure-params=" passwd  password " op-secure-digest="6cecd340b584b96981bffee3e535ff98"/>
+          </lrm_resource>
+          <lrm_resource id="nfs_snet_ip" type="IPaddr2" class="ocf" provider="heartbeat">
+            <lrm_rsc_op id="nfs_snet_ip_last_0" operation_key="nfs_snet_ip_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="55:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;55:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="67" rc-code="0" op-status="0" interval="0" last-run="1508577516" last-rc-change="1508577516" exec-time="4075" queue-time="0" op-digest="3318a8a5986a3f9535736f92159c8037"/>
+            <lrm_rsc_op id="nfs_snet_ip_monitor_10000" operation_key="nfs_snet_ip_monitor_10000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="56:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;56:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407888-db1" call-id="68" rc-code="0" op-status="0" interval="10000" last-rc-change="1508577520" exec-time="38" queue-time="0" op-digest="93e01a8306279f10eb7583786235ab86"/>
+            <lrm_rsc_op id="nfs_snet_ip_last_failure_0" operation_key="nfs_snet_ip_monitor_10000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="56:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:7;56:20:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" exit-reason="Unable to find nic or netmask." on_node="407888-db1" call-id="68" rc-code="7" op-status="0" interval="10000" last-rc-change="1509027829" exec-time="0" queue-time="0" op-digest="93e01a8306279f10eb7583786235ab86"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+      <transient_attributes id="1">
+        <instance_attributes id="status-1">
+          <nvpair id="status-1-shutdown" name="shutdown" value="0"/>
+          <nvpair id="status-1-fail-count-nfs_snet_ip" name="fail-count-nfs_snet_ip" value="2"/>
+          <nvpair id="status-1-last-failure-nfs_snet_ip" name="last-failure-nfs_snet_ip" value="1509027829"/>
+        </instance_attributes>
+      </transient_attributes>
+    </node_state>
+    <node_state id="2" uname="407892-db2" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="2">
+        <lrm_resources>
+          <lrm_resource id="fence_db1" type="fence_ipmilan" class="stonith">
+            <lrm_rsc_op id="fence_db1_last_0" operation_key="fence_db1_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="4:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;4:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407892-db2" call-id="6" rc-code="0" op-status="0" interval="0" last-run="1508577153" last-rc-change="1508577153" exec-time="116" queue-time="0" op-digest="5397ff9100b6061844743be1480cacb6" op-secure-params=" passwd  password " op-secure-digest="d7ead554cd349871ab13dad142fdd3f9"/>
+            <lrm_rsc_op id="fence_db1_monitor_60000" operation_key="fence_db1_monitor_60000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="5:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:0;5:3:0:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407892-db2" call-id="7" rc-code="0" op-status="0" interval="60000" last-rc-change="1508577154" exec-time="116" queue-time="0" op-digest="0f2ec8ca9089ba249057558bf057a7e8" op-secure-params=" passwd  password " op-secure-digest="d7ead554cd349871ab13dad142fdd3f9"/>
+          </lrm_resource>
+          <lrm_resource id="fence_db2" type="fence_ipmilan" class="stonith">
+            <lrm_rsc_op id="fence_db2_last_0" operation_key="fence_db2_monitor_0" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="4:4:7:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:7;4:4:7:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407892-db2" call-id="11" rc-code="7" op-status="0" interval="0" last-run="1508577161" last-rc-change="1508577161" exec-time="0" queue-time="0" op-digest="16a37bd94b2a5efbc774fb6ac0ed7a4c" op-secure-params=" passwd  password " op-secure-digest="6cecd340b584b96981bffee3e535ff98"/>
+          </lrm_resource>
+          <lrm_resource id="nfs_snet_ip" type="IPaddr2" class="ocf" provider="heartbeat">
+            <lrm_rsc_op id="nfs_snet_ip_last_0" operation_key="nfs_snet_ip_monitor_0" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.12" transition-key="9:14:7:dcc10f17-10a1-4e5d-89af-ef7ff033520d" transition-magic="0:7;9:14:7:dcc10f17-10a1-4e5d-89af-ef7ff033520d" on_node="407892-db2" call-id="44" rc-code="7" op-status="0" interval="0" last-run="1508577451" last-rc-change="1508577451" exec-time="39" queue-time="0" op-digest="3318a8a5986a3f9535736f92159c8037"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+      <transient_attributes id="2">
+        <instance_attributes id="status-2">
+          <nvpair id="status-2-shutdown" name="shutdown" value="0"/>
+        </instance_attributes>
+      </transient_attributes>
+    </node_state>
+  </status>
+</cib>