commit 1d735f077f7d2e6dfd7338c5e558564385535a77
Author: Andrew Beekhof <andrew@beekhof.net>
Date:   Thu May 25 17:27:17 2017 +1000

    Test: PE: Update regression tests for remote ordering

diff --git a/pengine/test10/remote-fence-before-reconnect.dot b/pengine/test10/remote-fence-before-reconnect.dot
index 2022b4cd7..ef2b047ef 100644
--- a/pengine/test10/remote-fence-before-reconnect.dot
+++ b/pengine/test10/remote-fence-before-reconnect.dot
@@ -6,6 +6,7 @@
 "fake2_start_0 c7auto1" -> "fake2_monitor_10000 c7auto1" [ style = bold]
 "fake2_start_0 c7auto1" [ style=bold color="green" fontcolor="black"]
 "fake2_stop_0 c7auto4" -> "all_stopped" [ style = bold]
+"fake2_stop_0 c7auto4" -> "c7auto4_stop_0 c7auto1" [ style = bold]
 "fake2_stop_0 c7auto4" -> "fake2_start_0 c7auto1" [ style = bold]
 "fake2_stop_0 c7auto4" [ style=bold color="green" fontcolor="orange"]
 "stonith 'reboot' c7auto4" -> "fake2_stop_0 c7auto4" [ style = bold]
diff --git a/pengine/test10/remote-fence-before-reconnect.exp b/pengine/test10/remote-fence-before-reconnect.exp
index 2c9ee6c07..54c910652 100644
--- a/pengine/test10/remote-fence-before-reconnect.exp
+++ b/pengine/test10/remote-fence-before-reconnect.exp
@@ -9,7 +9,11 @@
         </downed>
       </rsc_op>
     </action_set>
-    <inputs/>
+    <inputs>
+      <trigger>
+        <pseudo_event id="13" operation="stop" operation_key="fake2_stop_0"/>
+      </trigger>
+    </inputs>
   </synapse>
   <synapse id="1">
     <action_set>
diff --git a/pengine/test10/remote-fence-before-reconnect.summary b/pengine/test10/remote-fence-before-reconnect.summary
index 5cd8dd960..88ca48cfb 100644
--- a/pengine/test10/remote-fence-before-reconnect.summary
+++ b/pengine/test10/remote-fence-before-reconnect.summary
@@ -16,12 +16,12 @@ Transition Summary:
  * Move    fake2	(Started c7auto4 -> c7auto1)
 
 Executing cluster transition:
- * Resource action: c7auto4         stop on c7auto1
  * Fencing c7auto4 (reboot)
  * Pseudo action:   stonith_complete
  * Pseudo action:   fake2_stop_0
- * Pseudo action:   all_stopped
+ * Resource action: c7auto4         stop on c7auto1
  * Resource action: fake2           start on c7auto1
+ * Pseudo action:   all_stopped
  * Resource action: fake2           monitor=10000 on c7auto1
 
 Revised cluster status:
diff --git a/pengine/test10/remote-fence-unclean.dot b/pengine/test10/remote-fence-unclean.dot
index e956a9135..b2829a7c8 100644
--- a/pengine/test10/remote-fence-unclean.dot
+++ b/pengine/test10/remote-fence-unclean.dot
@@ -4,6 +4,7 @@
 "FAKE2_start_0 18builder" [ style=bold color="green" fontcolor="black"]
 "FAKE2_stop_0 remote1" -> "FAKE2_start_0 18builder" [ style = bold]
 "FAKE2_stop_0 remote1" -> "all_stopped" [ style = bold]
+"FAKE2_stop_0 remote1" -> "remote1_stop_0 18node1" [ style = bold]
 "FAKE2_stop_0 remote1" [ style=bold color="green" fontcolor="orange"]
 "FAKE3_monitor_60000 18node1" [ style=bold color="green" fontcolor="black"]
 "FAKE3_start_0 18node1" -> "FAKE3_monitor_60000 18node1" [ style = bold]
diff --git a/pengine/test10/remote-fence-unclean.exp b/pengine/test10/remote-fence-unclean.exp
index 125366ef5..d2c361730 100644
--- a/pengine/test10/remote-fence-unclean.exp
+++ b/pengine/test10/remote-fence-unclean.exp
@@ -25,7 +25,11 @@
         </downed>
       </rsc_op>
     </action_set>
-    <inputs/>
+    <inputs>
+      <trigger>
+        <pseudo_event id="13" operation="stop" operation_key="FAKE2_stop_0"/>
+      </trigger>
+    </inputs>
   </synapse>
   <synapse id="2">
     <action_set>
diff --git a/pengine/test10/remote-fence-unclean.summary b/pengine/test10/remote-fence-unclean.summary
index 60e70a51e..cd246e4c0 100644
--- a/pengine/test10/remote-fence-unclean.summary
+++ b/pengine/test10/remote-fence-unclean.summary
@@ -17,20 +17,20 @@ Transition Summary:
  * Move    FAKE4	(Started 18node1 -> 18node2)
 
 Executing cluster transition:
- * Resource action: remote1         stop on 18node1
  * Resource action: FAKE3           stop on 18builder
  * Resource action: FAKE4           stop on 18node1
  * Fencing remote1 (reboot)
  * Pseudo action:   stonith_complete
- * Resource action: remote1         start on 18node1
- * Resource action: remote1         monitor=60000 on 18node1
  * Pseudo action:   FAKE2_stop_0
  * Resource action: FAKE3           start on 18node1
  * Resource action: FAKE4           start on 18node2
- * Pseudo action:   all_stopped
+ * Resource action: remote1         stop on 18node1
  * Resource action: FAKE2           start on 18builder
  * Resource action: FAKE3           monitor=60000 on 18node1
  * Resource action: FAKE4           monitor=60000 on 18node2
+ * Pseudo action:   all_stopped
+ * Resource action: remote1         start on 18node1
+ * Resource action: remote1         monitor=60000 on 18node1
  * Resource action: FAKE2           monitor=60000 on 18builder
 
 Revised cluster status:
diff --git a/pengine/test10/remote-recover-fail.dot b/pengine/test10/remote-recover-fail.dot
index a92008943..7b6edaa41 100644
--- a/pengine/test10/remote-recover-fail.dot
+++ b/pengine/test10/remote-recover-fail.dot
@@ -7,6 +7,7 @@
 "FAKE2_start_0 rhel7-auto3" [ style=bold color="green" fontcolor="black"]
 "FAKE2_stop_0 rhel7-auto4" -> "FAKE2_start_0 rhel7-auto3" [ style = bold]
 "FAKE2_stop_0 rhel7-auto4" -> "all_stopped" [ style = bold]
+"FAKE2_stop_0 rhel7-auto4" -> "rhel7-auto4_stop_0 rhel7-auto2" [ style = bold]
 "FAKE2_stop_0 rhel7-auto4" [ style=bold color="green" fontcolor="orange"]
 "FAKE3_monitor_10000 rhel7-auto2" [ style=bold color="green" fontcolor="black"]
 "FAKE4_monitor_10000 rhel7-auto3" [ style=bold color="green" fontcolor="black"]
@@ -15,6 +16,7 @@
 "FAKE6_start_0 rhel7-auto2" [ style=bold color="green" fontcolor="black"]
 "FAKE6_stop_0 rhel7-auto4" -> "FAKE6_start_0 rhel7-auto2" [ style = bold]
 "FAKE6_stop_0 rhel7-auto4" -> "all_stopped" [ style = bold]
+"FAKE6_stop_0 rhel7-auto4" -> "rhel7-auto4_stop_0 rhel7-auto2" [ style = bold]
 "FAKE6_stop_0 rhel7-auto4" [ style=bold color="green" fontcolor="orange"]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
 "rhel7-auto4_monitor_60000 rhel7-auto2" [ style=bold color="green" fontcolor="black"]
diff --git a/pengine/test10/remote-recover-fail.exp b/pengine/test10/remote-recover-fail.exp
index 1daa510a6..be45b88fe 100644
--- a/pengine/test10/remote-recover-fail.exp
+++ b/pengine/test10/remote-recover-fail.exp
@@ -38,7 +38,14 @@
         </downed>
       </rsc_op>
     </action_set>
-    <inputs/>
+    <inputs>
+      <trigger>
+        <pseudo_event id="11" operation="stop" operation_key="FAKE2_stop_0"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="22" operation="stop" operation_key="FAKE6_stop_0"/>
+      </trigger>
+    </inputs>
   </synapse>
   <synapse id="3">
     <action_set>
diff --git a/pengine/test10/remote-recover-fail.summary b/pengine/test10/remote-recover-fail.summary
index 85847455b..5953e3459 100644
--- a/pengine/test10/remote-recover-fail.summary
+++ b/pengine/test10/remote-recover-fail.summary
@@ -20,22 +20,22 @@ Transition Summary:
  * Move    FAKE6	(Started rhel7-auto4 -> rhel7-auto2)
 
 Executing cluster transition:
- * Resource action: rhel7-auto4     stop on rhel7-auto2
  * Resource action: FAKE3           monitor=10000 on rhel7-auto2
  * Resource action: FAKE4           monitor=10000 on rhel7-auto3
  * Fencing rhel7-auto4 (reboot)
  * Pseudo action:   stonith_complete
- * Resource action: rhel7-auto4     start on rhel7-auto2
  * Resource action: FAKE1           start on rhel7-auto2
  * Pseudo action:   FAKE2_stop_0
  * Pseudo action:   FAKE6_stop_0
- * Pseudo action:   all_stopped
- * Resource action: rhel7-auto4     monitor=60000 on rhel7-auto2
+ * Resource action: rhel7-auto4     stop on rhel7-auto2
  * Resource action: FAKE1           monitor=10000 on rhel7-auto2
  * Resource action: FAKE2           start on rhel7-auto3
  * Resource action: FAKE6           start on rhel7-auto2
+ * Pseudo action:   all_stopped
+ * Resource action: rhel7-auto4     start on rhel7-auto2
  * Resource action: FAKE2           monitor=10000 on rhel7-auto3
  * Resource action: FAKE6           monitor=10000 on rhel7-auto2
+ * Resource action: rhel7-auto4     monitor=60000 on rhel7-auto2
 
 Revised cluster status:
 Online: [ rhel7-auto2 rhel7-auto3 ]