commit e6ce0e93255eb7dfe20fc0db56a81e6903090a01
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Mon Oct 16 18:00:18 2017 -0500

    Test: pengine: new regression test for restart cancelling reload

Index: pacemaker-1.1.16+20170320.77ea74d/pengine/regression.sh
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/regression.sh
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/regression.sh
@@ -96,6 +96,7 @@ do_test bug-lf-2106 "Restart all anonymo
 do_test params-6 "Params: Detect reload in previously migrated resource"
 do_test nvpair-id-ref "Support id-ref in nvpair with optional name"
 do_test not-reschedule-unneeded-monitor "Do not reschedule unneeded monitors while resource definitions have changed"
+do_test reload-becomes-restart "Cancel reload if restart becomes required"
 
 echo ""
 do_test target-0 "Target Role : baseline"
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.dot
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.dot
@@ -0,0 +1,54 @@
+digraph "g" {
+"Fencing_monitor_0 node1" -> "Fencing_start_0 node1" [ style = bold]
+"Fencing_monitor_0 node1" [ style=bold color="green" fontcolor="black"]
+"Fencing_monitor_0 node2" -> "Fencing_start_0 node1" [ style = bold]
+"Fencing_monitor_0 node2" [ style=bold color="green" fontcolor="black"]
+"Fencing_monitor_120000 node1" [ style=bold color="green" fontcolor="black"]
+"Fencing_start_0 node1" -> "Fencing_monitor_120000 node1" [ style = bold]
+"Fencing_start_0 node1" [ style=bold color="green" fontcolor="black"]
+"all_stopped" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc1_running_0" -> "cl-rsc2_start_0" [ style = bold]
+"cl-rsc1_running_0" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc1_start_0" -> "cl-rsc1_running_0" [ style = bold]
+"cl-rsc1_start_0" -> "rsc1:0_start_0 node2" [ style = bold]
+"cl-rsc1_start_0" -> "rsc1:1_start_0 node1" [ style = bold]
+"cl-rsc1_start_0" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc2_running_0" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc2_start_0" -> "cl-rsc2_running_0" [ style = bold]
+"cl-rsc2_start_0" -> "rsc2:1_start_0 node2" [ style = bold]
+"cl-rsc2_start_0" -> "rsc2_start_0 node1" [ style = bold]
+"cl-rsc2_start_0" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc2_stop_0" -> "cl-rsc2_stopped_0" [ style = bold]
+"cl-rsc2_stop_0" -> "rsc2_stop_0 node1" [ style = bold]
+"cl-rsc2_stop_0" [ style=bold color="green" fontcolor="orange"]
+"cl-rsc2_stopped_0" -> "cl-rsc2_start_0" [ style = bold]
+"cl-rsc2_stopped_0" [ style=bold color="green" fontcolor="orange"]
+"rsc1:0_monitor_0 node2" -> "cl-rsc1_start_0" [ style = bold]
+"rsc1:0_monitor_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc1:0_monitor_120000 node2" [ style=bold color="green" fontcolor="black"]
+"rsc1:0_start_0 node2" -> "cl-rsc1_running_0" [ style = bold]
+"rsc1:0_start_0 node2" -> "rsc1:0_monitor_120000 node2" [ style = bold]
+"rsc1:0_start_0 node2" -> "rsc2:1_start_0 node2" [ style = bold]
+"rsc1:0_start_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc1:1_monitor_0 node1" -> "cl-rsc1_start_0" [ style = bold]
+"rsc1:1_monitor_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc1:1_monitor_120000 node1" [ style=bold color="green" fontcolor="black"]
+"rsc1:1_start_0 node1" -> "cl-rsc1_running_0" [ style = bold]
+"rsc1:1_start_0 node1" -> "rsc1:1_monitor_120000 node1" [ style = bold]
+"rsc1:1_start_0 node1" -> "rsc2_start_0 node1" [ style = bold]
+"rsc1:1_start_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc2:1_monitor_0 node2" -> "cl-rsc2_start_0" [ style = bold]
+"rsc2:1_monitor_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc2:1_monitor_200000 node2" [ style=bold color="green" fontcolor="black"]
+"rsc2:1_start_0 node2" -> "cl-rsc2_running_0" [ style = bold]
+"rsc2:1_start_0 node2" -> "rsc2:1_monitor_200000 node2" [ style = bold]
+"rsc2:1_start_0 node2" [ style=bold color="green" fontcolor="black"]
+"rsc2_monitor_200000 node1" [ style=bold color="green" fontcolor="black"]
+"rsc2_start_0 node1" -> "cl-rsc2_running_0" [ style = bold]
+"rsc2_start_0 node1" -> "rsc2_monitor_200000 node1" [ style = bold]
+"rsc2_start_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc2_stop_0 node1" -> "all_stopped" [ style = bold]
+"rsc2_stop_0 node1" -> "cl-rsc2_stopped_0" [ style = bold]
+"rsc2_stop_0 node1" -> "rsc2_start_0 node1" [ style = bold]
+"rsc2_stop_0 node1" [ style=bold color="green" fontcolor="black"]
+}
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.exp
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.exp
@@ -0,0 +1,306 @@
+<transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
+  <synapse id="0">
+    <action_set>
+      <rsc_op id="10" operation="monitor" operation_key="Fencing_monitor_120000" on_node="node1" on_node_uuid="1">
+        <primitive id="Fencing" class="stonith" type="fence_xvm"/>
+        <attributes CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="120000"  multicast_address="239.255.100.100" pcmk_host_list="node1 node2"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="9" operation="start" operation_key="Fencing_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="1">
+    <action_set>
+      <rsc_op id="9" operation="start" operation_key="Fencing_start_0" on_node="node1" on_node_uuid="1">
+        <primitive id="Fencing" class="stonith" type="fence_xvm"/>
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000"  multicast_address="239.255.100.100" pcmk_host_list="node1 node2"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="Fencing_monitor_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="Fencing_monitor_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="2">
+    <action_set>
+      <rsc_op id="6" operation="monitor" operation_key="Fencing_monitor_0" on_node="node2" on_node_uuid="2">
+        <primitive id="Fencing" class="stonith" type="fence_xvm"/>
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="120000"  multicast_address="239.255.100.100" pcmk_host_list="node1 node2"/>
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="3">
+    <action_set>
+      <rsc_op id="4" operation="monitor" operation_key="Fencing_monitor_0" on_node="node1" on_node_uuid="1">
+        <primitive id="Fencing" class="stonith" type="fence_xvm"/>
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="120000"  multicast_address="239.255.100.100" pcmk_host_list="node1 node2"/>
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="4">
+    <action_set>
+      <rsc_op id="12" operation="monitor" operation_key="rsc1:0_monitor_120000" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc1" long-id="rsc1:0" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="11" operation="start" operation_key="rsc1:0_start_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="5">
+    <action_set>
+      <rsc_op id="11" operation="start" operation_key="rsc1:0_start_0" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc1" long-id="rsc1:0" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="15" operation="start" operation_key="cl-rsc1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6">
+    <action_set>
+      <rsc_op id="7" operation="monitor" operation_key="rsc1:0_monitor_0" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc1" long-id="rsc1:0" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="7">
+    <action_set>
+      <rsc_op id="14" operation="monitor" operation_key="rsc1:1_monitor_120000" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc1" long-id="rsc1:1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="120000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="13" operation="start" operation_key="rsc1:1_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="8">
+    <action_set>
+      <rsc_op id="13" operation="start" operation_key="rsc1:1_start_0" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc1" long-id="rsc1:1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="15" operation="start" operation_key="cl-rsc1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="9">
+    <action_set>
+      <rsc_op id="5" operation="monitor" operation_key="rsc1:1_monitor_0" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc1" long-id="rsc1:1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_op_target_rc="7" CRM_meta_timeout="60000" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="10" priority="1000000">
+    <action_set>
+      <pseudo_event id="16" operation="running" operation_key="cl-rsc1_running_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="11" operation="start" operation_key="rsc1:0_start_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="start" operation_key="rsc1:1_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="15" operation="start" operation_key="cl-rsc1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="11">
+    <action_set>
+      <pseudo_event id="15" operation="start" operation_key="cl-rsc1_start_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc1:1_monitor_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="rsc1:0_monitor_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="12">
+    <action_set>
+      <rsc_op id="20" operation="start" operation_key="rsc2_start_0" internal_operation_key="rsc2:0_start_0" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc2" long-id="rsc2:0" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="13" operation="start" operation_key="rsc1:1_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="19" operation="stop" operation_key="rsc2_stop_0" internal_operation_key="rsc2:0_stop_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="23" operation="start" operation_key="cl-rsc2_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="13">
+    <action_set>
+      <rsc_op id="19" operation="stop" operation_key="rsc2_stop_0" internal_operation_key="rsc2:0_stop_0" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc2" long-id="rsc2:0" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="25" operation="stop" operation_key="cl-rsc2_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="14">
+    <action_set>
+      <rsc_op id="1" operation="monitor" operation_key="rsc2_monitor_200000" internal_operation_key="rsc2:0_monitor_200000" on_node="node1" on_node_uuid="1">
+        <primitive id="rsc2" long-id="rsc2:0" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="200000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="20" operation="start" operation_key="rsc2_start_0" internal_operation_key="rsc2:0_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="15">
+    <action_set>
+      <rsc_op id="22" operation="monitor" operation_key="rsc2:1_monitor_200000" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc2" long-id="rsc2:1" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="200000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="21" operation="start" operation_key="rsc2:1_start_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="16">
+    <action_set>
+      <rsc_op id="21" operation="start" operation_key="rsc2:1_start_0" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc2" long-id="rsc2:1" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="11" operation="start" operation_key="rsc1:0_start_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="23" operation="start" operation_key="cl-rsc2_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="17">
+    <action_set>
+      <rsc_op id="8" operation="monitor" operation_key="rsc2:1_monitor_0" on_node="node2" on_node_uuid="2">
+        <primitive id="rsc2" long-id="rsc2:1" class="ocf" provider="custom" type="drbd-conf"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" block_device="/dev/VG_LOCAL/STORAGE_REPLICA"  minor="0" name="storage"/>
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="18" priority="1000000">
+    <action_set>
+      <pseudo_event id="26" operation="stopped" operation_key="cl-rsc2_stopped_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="19" operation="stop" operation_key="rsc2_stop_0" internal_operation_key="rsc2:0_stop_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="25" operation="stop" operation_key="cl-rsc2_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="19">
+    <action_set>
+      <pseudo_event id="25" operation="stop" operation_key="cl-rsc2_stop_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="20" priority="1000000">
+    <action_set>
+      <pseudo_event id="24" operation="running" operation_key="cl-rsc2_running_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="20" operation="start" operation_key="rsc2_start_0" internal_operation_key="rsc2:0_start_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="21" operation="start" operation_key="rsc2:1_start_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="23" operation="start" operation_key="cl-rsc2_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="21">
+    <action_set>
+      <pseudo_event id="23" operation="start" operation_key="cl-rsc2_start_0">
+        <attributes CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="rsc2:1_monitor_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="16" operation="running" operation_key="cl-rsc1_running_0"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="26" operation="stopped" operation_key="cl-rsc2_stopped_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="22">
+    <action_set>
+      <pseudo_event id="2" operation="all_stopped" operation_key="all_stopped">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="19" operation="stop" operation_key="rsc2_stop_0" internal_operation_key="rsc2:0_stop_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+</transition_graph>
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.scores
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.scores
@@ -0,0 +1,24 @@
+Allocation scores:
+Using the original execution date of: 2016-12-12 20:28:26Z
+clone_color: cl-rsc1 allocation score on node1: 0
+clone_color: cl-rsc1 allocation score on node2: 0
+clone_color: cl-rsc2 allocation score on node1: 0
+clone_color: cl-rsc2 allocation score on node2: 0
+clone_color: rsc1:0 allocation score on node1: 0
+clone_color: rsc1:0 allocation score on node2: 0
+clone_color: rsc1:1 allocation score on node1: 0
+clone_color: rsc1:1 allocation score on node2: 0
+clone_color: rsc2:0 allocation score on node1: 1
+clone_color: rsc2:0 allocation score on node2: 0
+clone_color: rsc2:1 allocation score on node1: 0
+clone_color: rsc2:1 allocation score on node2: 0
+native_color: Fencing allocation score on node1: 0
+native_color: Fencing allocation score on node2: 0
+native_color: rsc1:0 allocation score on node1: 0
+native_color: rsc1:0 allocation score on node2: 0
+native_color: rsc1:1 allocation score on node1: 0
+native_color: rsc1:1 allocation score on node2: -INFINITY
+native_color: rsc2:0 allocation score on node1: 1
+native_color: rsc2:0 allocation score on node2: 0
+native_color: rsc2:1 allocation score on node1: -INFINITY
+native_color: rsc2:1 allocation score on node2: 0
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.summary
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.summary
@@ -0,0 +1,54 @@
+Using the original execution date of: 2016-12-12 20:28:26Z
+
+Current cluster status:
+Online: [ node1 node2 ]
+
+ Fencing	(stonith:fence_xvm):	Stopped
+ Clone Set: cl-rsc1 [rsc1]
+     Stopped: [ node1 node2 ]
+ Clone Set: cl-rsc2 [rsc2]
+     Started: [ node1 ]
+     Stopped: [ node2 ]
+
+Transition Summary:
+ * Start      Fencing     ( node1 )  
+ * Start      rsc1:0      ( node2 )  
+ * Start      rsc1:1      ( node1 )  
+ * Restart rsc2:0	(Started node1)
+ * Start      rsc2:1      ( node2 )  
+
+Executing cluster transition:
+ * Resource action: Fencing         monitor on node2
+ * Resource action: Fencing         monitor on node1
+ * Resource action: rsc1:0          monitor on node2
+ * Resource action: rsc1:1          monitor on node1
+ * Pseudo action:   cl-rsc1_start_0
+ * Resource action: rsc2            monitor on node2
+ * Pseudo action:   cl-rsc2_stop_0
+ * Resource action: Fencing         start on node1
+ * Resource action: rsc1:0          start on node2
+ * Resource action: rsc1:1          start on node1
+ * Pseudo action:   cl-rsc1_running_0
+ * Resource action: rsc2            stop on node1
+ * Pseudo action:   cl-rsc2_stopped_0
+ * Pseudo action:   cl-rsc2_start_0
+ * Pseudo action:   all_stopped
+ * Resource action: Fencing         monitor=120000 on node1
+ * Resource action: rsc1:0          monitor=120000 on node2
+ * Resource action: rsc1:1          monitor=120000 on node1
+ * Resource action: rsc2            start on node1
+ * Resource action: rsc2            monitor=200000 on node1
+ * Resource action: rsc2            start on node2
+ * Pseudo action:   cl-rsc2_running_0
+ * Resource action: rsc2            monitor=200000 on node2
+Using the original execution date of: 2016-12-12 20:28:26Z
+
+Revised cluster status:
+Online: [ node1 node2 ]
+
+ Fencing	(stonith:fence_xvm):	Started node1
+ Clone Set: cl-rsc1 [rsc1]
+     Started: [ node1 node2 ]
+ Clone Set: cl-rsc2 [rsc2]
+     Started: [ node1 node2 ]
+
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.xml
===================================================================
--- /dev/null
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/reload-becomes-restart.xml
@@ -0,0 +1,75 @@
+<cib crm_feature_set="3.0.7" validate-with="pacemaker-1.2" epoch="79" num_updates="0" admin_epoch="0" cib-last-written="Mon Dec 12 20:28:26 2016" update-origin="node1" update-client="cibadmin" update-user="root" have-quorum="1" dc-uuid="1" execution-date="1481574506">
+  <configuration>
+    <crm_config>
+      <cluster_property_set id="cib-bootstrap-options">
+        <nvpair id="cib-bootstrap-options-have-watchdog" name="have-watchdog" value="false"/>
+        <nvpair id="cib-bootstrap-options-dc-version" name="dc-version" value="1.1.16-1"/>
+        <nvpair id="cib-bootstrap-options-cluster-infrastructure" name="cluster-infrastructure" value="corosync"/>
+        <nvpair id="cib-bootstrap-options-cluster-name" name="cluster-name" value="cluster"/>
+        <nvpair id="cib-bootstrap-options-last-lrm-refresh" name="last-lrm-refresh" value="1481569160"/>
+      </cluster_property_set>
+    </crm_config>
+    <nodes>
+      <node id="1" uname="node1" />
+      <node id="2" uname="node2" />
+    </nodes>
+    <resources>
+      <primitive id="Fencing" class="stonith" type="fence_xvm">
+        <meta_attributes id="Fencing-meta">
+        </meta_attributes>
+        <instance_attributes id="Fencing-params">
+          <nvpair id="Fencing-multicast_address" name="multicast_address" value="239.255.100.100"/>
+          <nvpair id="Fencing-pcmk_host_list" name="pcmk_host_list" value="node1 node2"/>
+        </instance_attributes>
+        <operations>
+          <op id="Fencing-monitor-120s" interval="120s" name="monitor" timeout="120s"/>
+        </operations>
+      </primitive>
+      <clone id="cl-rsc1">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy">
+          <meta_attributes id="rsc1-meta" />
+          <instance_attributes id="rsc1-instance" />
+          <operations>
+            <op name="monitor" interval="120" timeout="60" id="rsc1-monitor-120"/>
+          </operations>
+        </primitive>
+      </clone>
+      <clone id="cl-rsc2">
+        <meta_attributes id="cl-rsc2-meta_attributes">
+          <nvpair name="interleave" value="true" id="cl-rsc2-meta_attributes-interleave"/>
+        </meta_attributes>
+        <primitive id="rsc2" class="ocf" provider="custom" type="drbd-conf">
+          <instance_attributes id="rsc2-instance_attributes-0">
+            <nvpair name="name" value="storage" id="rsc2-instance_attributes-0-name"/>
+            <nvpair name="minor" value="0" id="rsc2-instance_attributes-0-minor"/>
+            <nvpair name="block_device" value="/dev/VG_LOCAL/STORAGE_REPLICA" id="rsc2-instance_attributes-0-block_device"/>
+          </instance_attributes>
+          <operations>
+            <op name="monitor" interval="200" timeout="20" id="rsc2-monitor-200"/>
+          </operations>
+        </primitive>
+      </clone>
+    </resources>
+    <constraints>
+      <rsc_order id="rsc2-after-rsc1" score="INFINITY" first="cl-rsc1" first-action="start" then="cl-rsc2" then-action="start"/>
+    </constraints>
+  </configuration>
+  <status>
+    <node_state id="1" uname="node1" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="1">
+        <lrm_resources>
+          <lrm_resource id="rsc2" type="drbd-conf" class="ocf" provider="custom">
+            <lrm_rsc_op id="rsc2_last_0" operation_key="rsc2_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.11" transition-key="398:1:0:869e8bd0-6e94-403e-be1a-cbaee812e740" transition-magic="0:0;398:1:0:869e8bd0-6e94-403e-be1a-cbaee812e740" on_node="node1" call-id="277" rc-code="0" op-status="0" interval="0" last-run="1481567978" last-rc-change="1481567978" exec-time="312" queue-time="0" op-digest="f2ee9bb733c6b1e04b6b03933cae3481" op-force-restart=" name  minor  block_device " op-restart-digest="41b1da4c2ea2b5ced1c615df108064b0"/>
+            <lrm_rsc_op id="rsc2_monitor_200000" operation_key="rsc2_monitor_200000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.11" transition-key="399:1:0:869e8bd0-6e94-403e-be1a-cbaee812e740" transition-magic="0:0;399:1:0:869e8bd0-6e94-403e-be1a-cbaee812e740" on_node="node1" call-id="294" rc-code="0" op-status="0" interval="200000" last-rc-change="1481567979" exec-time="37" queue-time="62" op-digest="c2fb74c6b28a8e8e687a52f4134a0147"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+    <node_state id="2" uname="node2" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="2">
+        <lrm_resources>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+  </status>
+</cib>