commit 7a3dbd5fd5481ecc3a375d9874f01daac6512943
Author: Andrew Beekhof <andrew@beekhof.net>
Date:   Wed Aug 16 13:50:07 2017 +1000

    Test: PE: Update unfencing device change test output

Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.summary
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/test10/unfence-parameters.summary
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.summary
@@ -14,11 +14,9 @@ Online: [ virt-1 virt-2 virt-3 ]
 Transition Summary:
  * Fence (reboot) virt-4
  * Fence (on) virt-3
- * Fence (on) virt-2
  * Fence (on) virt-1
  * Restart fencing	(Started virt-1)
  * Restart dlm:0	(Started virt-1)
- * Restart dlm:1	(Started virt-2)
  * Start   dlm:2	(virt-3)
  * Restart clvmd:0	(Started virt-1)
  * Start   clvmd:1	(virt-2)
@@ -37,8 +35,6 @@ Executing cluster transition:
  * Pseudo action:   clvmd-clone_stopped_0
  * Resource action: fencing         stop on virt-1
  * Pseudo action:   dlm-clone_stop_0
- * Resource action: dlm             stop on virt-2
- * Fencing virt-2 (on)
  * Resource action: dlm             stop on virt-1
  * Pseudo action:   dlm-clone_stopped_0
  * Pseudo action:   dlm-clone_start_0
@@ -46,7 +42,6 @@ Executing cluster transition:
  * Pseudo action:   all_stopped
  * Resource action: fencing         start on virt-1
  * Resource action: dlm             start on virt-1
- * Resource action: dlm             start on virt-2
  * Resource action: dlm             start on virt-3
  * Pseudo action:   dlm-clone_running_0
  * Pseudo action:   clvmd-clone_start_0
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.dot
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/test10/unfence-parameters.dot
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.dot
@@ -14,7 +14,6 @@ digraph "g" {
 "clvmd-clone_stopped_0" -> "dlm-clone_stop_0" [ style = bold]
 "clvmd-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
 "clvmd:1_monitor_0 virt-2" -> "clvmd-clone_start_0" [ style = bold]
-"clvmd:1_monitor_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
 "clvmd:1_monitor_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "clvmd:1_start_0 virt-2" -> "clvmd-clone_running_0" [ style = bold]
 "clvmd:1_start_0 virt-2" -> "clvmd:2_start_0 virt-3" [ style = bold]
@@ -23,10 +22,7 @@ digraph "g" {
 "clvmd:2_monitor_0 virt-3" -> "stonith 'on' virt-3" [ style = bold]
 "clvmd:2_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "clvmd:2_start_0 virt-3" -> "clvmd-clone_running_0" [ style = bold]
-"clvmd:2_start_0 virt-3" -> "clvmd:3_start_0 <none>" [ style = dashed]
 "clvmd:2_start_0 virt-3" [ style=bold color="green" fontcolor="black"]
-"clvmd:3_start_0 <none>" -> "clvmd-clone_running_0" [ style = dashed]
-"clvmd:3_start_0 <none>" [ style=dashed color="red" fontcolor="black"]
 "clvmd_start_0 virt-1" -> "clvmd-clone_running_0" [ style = bold]
 "clvmd_start_0 virt-1" -> "clvmd:1_start_0 virt-2" [ style = bold]
 "clvmd_start_0 virt-1" [ style=bold color="green" fontcolor="black"]
@@ -41,11 +37,9 @@ digraph "g" {
 "dlm-clone_start_0" -> "dlm-clone_running_0" [ style = bold]
 "dlm-clone_start_0" -> "dlm:2_start_0 virt-3" [ style = bold]
 "dlm-clone_start_0" -> "dlm_start_0 virt-1" [ style = bold]
-"dlm-clone_start_0" -> "dlm_start_0 virt-2" [ style = bold]
 "dlm-clone_start_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stop_0" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm-clone_stop_0" -> "dlm_stop_0 virt-1" [ style = bold]
-"dlm-clone_stop_0" -> "dlm_stop_0 virt-2" [ style = bold]
 "dlm-clone_stop_0" [ style=bold color="green" fontcolor="orange"]
 "dlm-clone_stopped_0" -> "dlm-clone_start_0" [ style = bold]
 "dlm-clone_stopped_0" [ style=bold color="green" fontcolor="orange"]
@@ -57,24 +51,12 @@ digraph "g" {
 "dlm:2_start_0 virt-3" [ style=bold color="green" fontcolor="black"]
 "dlm_start_0 virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "dlm_start_0 virt-1" -> "dlm-clone_running_0" [ style = bold]
-"dlm_start_0 virt-1" -> "dlm_start_0 virt-2" [ style = bold]
 "dlm_start_0 virt-1" [ style=bold color="green" fontcolor="black"]
-"dlm_start_0 virt-2" -> "clvmd:1_start_0 virt-2" [ style = bold]
-"dlm_start_0 virt-2" -> "clvmd:3_start_0 <none>" [ style = dashed]
-"dlm_start_0 virt-2" -> "dlm-clone_running_0" [ style = bold]
-"dlm_start_0 virt-2" -> "dlm:2_start_0 virt-3" [ style = bold]
-"dlm_start_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "dlm_stop_0 virt-1" -> "all_stopped" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm-clone_stopped_0" [ style = bold]
 "dlm_stop_0 virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "dlm_stop_0 virt-1" -> "stonith 'on' virt-1" [ style = bold]
 "dlm_stop_0 virt-1" [ style=bold color="green" fontcolor="black"]
-"dlm_stop_0 virt-2" -> "all_stopped" [ style = bold]
-"dlm_stop_0 virt-2" -> "dlm-clone_stopped_0" [ style = bold]
-"dlm_stop_0 virt-2" -> "dlm_start_0 virt-2" [ style = bold]
-"dlm_stop_0 virt-2" -> "dlm_stop_0 virt-1" [ style = bold]
-"dlm_stop_0 virt-2" -> "stonith 'on' virt-2" [ style = bold]
-"dlm_stop_0 virt-2" [ style=bold color="green" fontcolor="black"]
 "fencing_monitor_0 virt-3" -> "fencing_start_0 virt-1" [ style = bold]
 "fencing_monitor_0 virt-3" -> "fencing_stop_0 virt-1" [ style = bold]
 "fencing_monitor_0 virt-3" [ style=bold color="green" fontcolor="black"]
@@ -85,9 +67,6 @@ digraph "g" {
 "stonith 'on' virt-1" -> "clvmd_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" -> "dlm_start_0 virt-1" [ style = bold]
 "stonith 'on' virt-1" [ style=bold color="green" fontcolor="black"]
-"stonith 'on' virt-2" -> "clvmd:1_start_0 virt-2" [ style = bold]
-"stonith 'on' virt-2" -> "dlm_start_0 virt-2" [ style = bold]
-"stonith 'on' virt-2" [ style=bold color="green" fontcolor="black"]
 "stonith 'on' virt-3" -> "clvmd:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith 'on' virt-3" -> "fencing_monitor_0 virt-3" [ style = bold]
@@ -100,6 +79,5 @@ digraph "g" {
 "stonith_complete" -> "clvmd_start_0 virt-1" [ style = bold]
 "stonith_complete" -> "dlm:2_start_0 virt-3" [ style = bold]
 "stonith_complete" -> "dlm_start_0 virt-1" [ style = bold]
-"stonith_complete" -> "dlm_start_0 virt-2" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange"]
 }
Index: pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.exp
===================================================================
--- pacemaker-1.1.16+20170320.77ea74d.orig/pengine/test10/unfence-parameters.exp
+++ pacemaker-1.1.16+20170320.77ea74d/pengine/test10/unfence-parameters.exp
@@ -75,9 +75,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="19" operation="stop" operation_key="dlm-clone_stop_0"/>
       </trigger>
       <trigger>
@@ -87,44 +84,6 @@
   </synapse>
   <synapse id="5">
     <action_set>
-      <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2">
-        <primitive id="dlm" long-id="dlm:1" class="ocf" provider="pacemaker" type="controld"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="virt-2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
-      </rsc_op>
-    </action_set>
-    <inputs>
-      <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <rsc_op id="13" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:0_start_0" on_node="virt-1" on_node_uuid="1"/>
-      </trigger>
-      <trigger>
-        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="17" operation="start" operation_key="dlm-clone_start_0"/>
-      </trigger>
-      <trigger>
-        <pseudo_event id="29" operation="stonith_complete" operation_key="stonith_complete"/>
-      </trigger>
-    </inputs>
-  </synapse>
-  <synapse id="6">
-    <action_set>
-      <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2">
-        <primitive id="dlm" long-id="dlm:1" class="ocf" provider="pacemaker" type="controld"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="virt-2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
-      </rsc_op>
-    </action_set>
-    <inputs>
-      <trigger>
-        <pseudo_event id="19" operation="stop" operation_key="dlm-clone_stop_0"/>
-      </trigger>
-    </inputs>
-  </synapse>
-  <synapse id="7">
-    <action_set>
       <rsc_op id="16" operation="start" operation_key="dlm:2_start_0" on_node="virt-3" on_node_uuid="3">
         <primitive id="dlm" long-id="dlm:2" class="ocf" provider="pacemaker" type="controld"/>
         <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="virt-3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="20000" />
@@ -135,9 +94,6 @@
         <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
-        <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="17" operation="start" operation_key="dlm-clone_start_0"/>
       </trigger>
       <trigger>
@@ -145,7 +101,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="8">
+  <synapse id="6">
     <action_set>
       <rsc_op id="9" operation="monitor" operation_key="dlm:2_monitor_0" on_node="virt-3" on_node_uuid="3">
         <primitive id="dlm" long-id="dlm:2" class="ocf" provider="pacemaker" type="controld"/>
@@ -154,7 +110,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="9" priority="1000000">
+  <synapse id="7" priority="1000000">
     <action_set>
       <pseudo_event id="20" operation="stopped" operation_key="dlm-clone_stopped_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -165,14 +121,11 @@
         <rsc_op id="12" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <pseudo_event id="19" operation="stop" operation_key="dlm-clone_stop_0"/>
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="10">
+  <synapse id="8">
     <action_set>
       <pseudo_event id="19" operation="stop" operation_key="dlm-clone_stop_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -184,7 +137,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="11" priority="1000000">
+  <synapse id="9" priority="1000000">
     <action_set>
       <pseudo_event id="18" operation="running" operation_key="dlm-clone_running_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -195,9 +148,6 @@
         <rsc_op id="13" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:0_start_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <rsc_op id="16" operation="start" operation_key="dlm:2_start_0" on_node="virt-3" on_node_uuid="3"/>
       </trigger>
       <trigger>
@@ -205,7 +155,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="12">
+  <synapse id="10">
     <action_set>
       <pseudo_event id="17" operation="start" operation_key="dlm-clone_start_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -220,7 +170,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="13">
+  <synapse id="11">
     <action_set>
       <rsc_op id="22" operation="start" operation_key="clvmd_start_0" internal_operation_key="clvmd:0_start_0" on_node="virt-1" on_node_uuid="1">
         <primitive id="clvmd" long-id="clvmd:0" class="ocf" provider="heartbeat" type="clvm"/>
@@ -245,7 +195,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="14">
+  <synapse id="12">
     <action_set>
       <rsc_op id="21" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1">
         <primitive id="clvmd" long-id="clvmd:0" class="ocf" provider="heartbeat" type="clvm"/>
@@ -258,7 +208,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="15">
+  <synapse id="13">
     <action_set>
       <rsc_op id="23" operation="start" operation_key="clvmd:1_start_0" on_node="virt-2" on_node_uuid="2">
         <primitive id="clvmd" long-id="clvmd:1" class="ocf" provider="heartbeat" type="clvm"/>
@@ -267,12 +217,6 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <rsc_op id="15" operation="start" operation_key="dlm_start_0" internal_operation_key="dlm:1_start_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <rsc_op id="22" operation="start" operation_key="clvmd_start_0" internal_operation_key="clvmd:0_start_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
@@ -283,7 +227,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="16">
+  <synapse id="14">
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2">
         <primitive id="clvmd" long-id="clvmd:1" class="ocf" provider="heartbeat" type="clvm"/>
@@ -292,7 +236,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="17">
+  <synapse id="15">
     <action_set>
       <rsc_op id="24" operation="start" operation_key="clvmd:2_start_0" on_node="virt-3" on_node_uuid="3">
         <primitive id="clvmd" long-id="clvmd:2" class="ocf" provider="heartbeat" type="clvm"/>
@@ -317,7 +261,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="18">
+  <synapse id="16">
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="clvmd:2_monitor_0" on_node="virt-3" on_node_uuid="3">
         <primitive id="clvmd" long-id="clvmd:2" class="ocf" provider="heartbeat" type="clvm"/>
@@ -326,7 +270,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="19" priority="1000000">
+  <synapse id="17" priority="1000000">
     <action_set>
       <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -341,7 +285,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="20">
+  <synapse id="18">
     <action_set>
       <pseudo_event id="27" operation="stop" operation_key="clvmd-clone_stop_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -349,7 +293,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="21" priority="1000000">
+  <synapse id="19" priority="1000000">
     <action_set>
       <pseudo_event id="26" operation="running" operation_key="clvmd-clone_running_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -370,7 +314,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="22">
+  <synapse id="20">
     <action_set>
       <pseudo_event id="25" operation="start" operation_key="clvmd-clone_start_0">
         <attributes CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
@@ -391,7 +335,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="23">
+  <synapse id="21">
     <action_set>
       <crm_event id="30" operation="stonith" operation_key="stonith-virt-4-reboot" on_node="virt-4" on_node_uuid="4">
         <attributes CRM_meta_on_node="virt-4" CRM_meta_on_node_uuid="4" CRM_meta_stonith_action="reboot" />
@@ -402,7 +346,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="24">
+  <synapse id="22">
     <action_set>
       <pseudo_event id="29" operation="stonith_complete" operation_key="stonith_complete">
         <attributes />
@@ -414,7 +358,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="25">
+  <synapse id="23">
     <action_set>
       <crm_event id="4" operation="stonith" operation_key="stonith-virt-3-on" on_node="virt-3" on_node_uuid="3">
         <attributes CRM_meta_on_node="virt-3" CRM_meta_on_node_uuid="3" CRM_meta_stonith_action="on" />
@@ -429,22 +373,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="26">
-    <action_set>
-      <crm_event id="3" operation="stonith" operation_key="stonith-virt-2-on" on_node="virt-2" on_node_uuid="2">
-        <attributes CRM_meta_on_node="virt-2" CRM_meta_on_node_uuid="2" CRM_meta_stonith_action="on" />
-      </crm_event>
-    </action_set>
-    <inputs>
-      <trigger>
-        <rsc_op id="7" operation="monitor" operation_key="clvmd:1_monitor_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
-        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-    </inputs>
-  </synapse>
-  <synapse id="27">
+  <synapse id="24">
     <action_set>
       <crm_event id="2" operation="stonith" operation_key="stonith-virt-1-on" on_node="virt-1" on_node_uuid="1">
         <attributes CRM_meta_on_node="virt-1" CRM_meta_on_node_uuid="1" CRM_meta_stonith_action="on" />
@@ -459,7 +388,7 @@
       </trigger>
     </inputs>
   </synapse>
-  <synapse id="28">
+  <synapse id="25">
     <action_set>
       <pseudo_event id="1" operation="all_stopped" operation_key="all_stopped">
         <attributes />
@@ -473,9 +402,6 @@
         <rsc_op id="12" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>
-        <rsc_op id="14" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:1_stop_0" on_node="virt-2" on_node_uuid="2"/>
-      </trigger>
-      <trigger>
         <rsc_op id="21" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0" on_node="virt-1" on_node_uuid="1"/>
       </trigger>
       <trigger>